<!-- addGoods 购买商品 -->
<template>
  <div class="addGoods">
    <van-popup :style="{ 'min-height': '7rem' }" position="bottom" v-model="Show" :close-on-click-overlay="false" :closeable="true" close-icon="close">
      <div class="conetent-box" v-if="Show">
        <div class="flex info-top">
          <div class="img-boxs">
            <van-image class="bgfff avatar" width="1.5rem" height="1.5rem" fit="cover" :src="getImg() | avatar" />
          </div>
          <div>
            <div class="goods-price"> ¥{{dynamicPrice}}</div>
            <!-- <div class="goods-lable">已选：{{'ssss'}}</div> -->
            <div  class="goods-lable">库存：{{checkGoods.stock}}</div>
          </div>

        </div>

       <div class="spec-box-box">
        <div v-for="(item ,index) in spec" :key="index" class="spec-box">
          <div class="spec">{{item.title}}:</div>
          <div class="cf">
            <div class="fl specItem" :class="{'active':hasActive(specItem,item),'disabled':hasNoStock(specItem,item)}" @click="clickSpec(specItem,item)" v-for="(specItem , i) in item.spec_item" :key="i">{{specItem.title}}</div>
          </div>
        </div>
        </div>

        <div class="flex flex-m flex-b mt20">
          <div>数量</div>
          <van-stepper v-model="num" integer :max="+checkGoods.stock" />
        </div>

        <van-button class="submit" @click="submit" size="large" :color="m_color">确定</van-button>

      </div>
    </van-popup>

  </div>
</template>

<script>
export default {
  name: 'addGoods',
  props: {
    value: {
      type: Boolean
    },
    info: {
      type: Object
    },
  },
  watch: {
    num() {
      return this.setDynamicPrice()
    },
  },
  computed: {
    Show: {
      set(v) {
        this.$emit('input', v)
      },
      get() {
        return this.value
      }
    },
    //选中的规格
    checkGoods() {
        if (!this.checkSpec.length) {
        //没有规格直接返回商品价格
        return this.getDefaultgoods()
      }
      let goods = this.findOptionsItem(this.options, this.checkSpec)
      if (!goods) {
        return this.getDefaultgoods()
      }
      this.dynamicPrice = goods.price
      return goods

    },
  },
  data() {
    return {
      num: 1,
      spec: [],
      //checkGoods: {},
      checkSpec: [],//选择的规格
      options: [], //全部商品规格
      noStock: [], //没有库存的规格
      canPurchase: true,
      dynamicPrice: ''
    }
  },
  created() {
  },

  mounted() {
    this.init()
    this.setDynamicPrice()
  },
  methods: {
    //初始化方法
    init() {
      this.initData()
    },
    setDynamicPrice() {
      let price = this.getPrice()
      if((this.info.item_endprice != null && this.info.item_endprice > 0) && this.info.min_item_endprice > 0 && this.num >= this.info.min_item_endprice)
      {
        price = this.info.item_endprice
      }
      this.dynamicPrice = price
      return price
    },
    initData() {
      let options = this._dep(this.info.options) || {}
      let spec = options.spec || []
      spec.forEach(e => {
        let spec_item = e.spec_item || []
        spec_item.forEach(i => {
          i.disabled = false
        })

      })
      this.spec = this._dep(spec)
      this.options = options.options
      let noStock = this.options.filter(i => i.stock == 0)
      this.noStock = noStock

    },

    getImg() {
      return this.checkGoods.images
    },
    getPrice() {
      return this.checkGoods.price
    },

    //获取已选中规格
    getCheckGoods() {
      return this._dep(this.checkGoods)
    },


    close() {
      this.Show = false
    },

    submit() {
        if (!this.canPurchase) {
            this.m_toast('限购产品只许够买一次');
            return;
      }

      if (this.options.length) {
        let checkLen = this.checkSpec.length
        let specLen = this.spec.length
        if (checkLen !== specLen) {
          this.m_toast('请选择规格');
          return;
        }
      }
      let price = this.setDynamicPrice()
      let data = {
        num: this.num,
        option_id: this.getCheckGoods().id || '0',
        images: this.getImg(),
        price: price,
        total: price * this.num,
        option_name: this.getCheckGoods().title
      }
      if (this.getCheckGoods().noOptions) {
        data.option_id = '0'
        data.option_name = ''
      }
      this.$emit('comfirm', data)
    },

    //点击规格
    clickSpec(item, pitem) {
      if (this.hasNoStock(item, pitem)) {
        console.log('没有规格不能选')
        return
      }
      let spec = this.createSpec(item, pitem)
      this.handelSpecKey(spec)

    },

    //判断规格里面是否有该规格的项
    handelSpecKey(obj) {
      let o = this._dep(obj)
      let index = this.checkSpec.findIndex(i => {
        return i.key == obj.key
      })
      if (index != -1) {
        if (!this.hasSpec(obj)) {
          //是否已经选中
          this.checkSpec.splice(index, 1, o)
        } else {
          return
        }

      } else {
        this.checkSpec.push(o)
      }

    },

    //创建默认规格
    getDefaultgoods() {
      let defGoods = this._dep(this.info)
      defGoods.images = defGoods.images[0]
      defGoods.noOptions = true;
      if(!defGoods.canBuyMoreThenOne){
          defGoods.stock = 1;
      }
      this.canPurchase = defGoods.can_purchase_this_good;
      return this._dep(defGoods);

    },

    //生成规格项
    createSpec(item, pitem) {
      let spec = {
        key: pitem.title,
        name: item.title
      }
      return this._dep(spec)
    },

    //判断规则是否被选中
    hasSpec(obj, checkSpec = this.checkSpec) {
      let item = checkSpec.find(i => {
        return this.isEqObj(i, obj)
      })
      return item
    },

    //判断是否选中高亮
    hasActive(item, pitem) {
      let spec = this.createSpec(item, pitem)
      return !!this.hasSpec(spec)
    },

    //获取已选择的规格
    findOptionsItem(options, checkSpec) {
      let item = options.find(i => {
        let targetObj = this.arrayToObj(i.specs)
        let arrObj = this.arrayToObj(checkSpec)
        return this.isEqObj(targetObj, arrObj)
      })
      return item
    },


    //数组变对象
    arrayToObj(arr) {
      let obj = {}
      arr.forEach(i => {
        obj[i.key] = i.name
      })
      return this._dep(obj)

    },

    //判断对象是否相等
    isEqObj(obj1, obj2) {
      let o1 = this._dep(obj1)
      let o2 = this._dep(obj2)
      let o1Keys = Object.keys(o1)
      let o2Keys = Object.keys(o2)
      if (o1Keys.length != o2Keys.length) { return false }
      for (let len = o1Keys.length; len--;) {
        let key = o1Keys[len]
        if (o1[key] != o2[key]) {
          return false
        }
      }
      return true

    },

    //是否没库存
    hasNoStock(item, pitem) {
      let spec = this.createSpec(item, pitem)
      let checkSpec = this._dep(this.checkSpec)
      let index = checkSpec.findIndex(i => {
        return i.key == spec.key
      })
      if (index != -1) {
        if (!this.hasSpec(spec, this.checkSpec)) {
          //是否已经选中
          checkSpec.splice(index, 1, spec)
        } else {

        }

      } else {
        checkSpec.push(spec)
      }
      let falg = !!this.findOptionsItem(this.noStock, checkSpec)
      return falg






    }


  },
}

</script>
<style lang='scss' scoped>
.conetent-box {
  padding: 0 0.26rem 1.3rem 0.26rem;
  box-sizing: border-box;
}
.info-top {
  padding-bottom: 0.3rem;
  border-bottom: 1px solid #eee;
}
.img-boxs {
  margin-top: -0.5rem;
  padding: 0.1rem;
  background: #fff;
  border: 1px solid #eee;
}

.goods-price {
  color: #ff5555;
  font-size: 0.32rem;
  padding-top: 0.2rem;
  padding-left: 0.3rem;
}

.submit {
  position: absolute;
  bottom: 0;
  left: 0;
}

.spec-box-box{
  max-height: 8rem;
  overflow: auto;
    -webkit-overflow-scrolling: touch;
}

.spec-box {
  font-size: 0.28rem;
  color: #000;
  padding-top: 0.1rem;
  padding-bottom: 0.1rem;
  border-bottom: 1px solid #eee;

  .spec {
    margin-bottom: 0.1rem;
  }
  .specItem {
    padding: 0.1rem 0.1rem;
    background: #f7f8fa;
    border-radius: 0.1rem;
    margin-right: 0.2rem;
    margin-bottom: 0.2rem;
    color: #555;
    &.active {
      color: #ee0a24 !important;
      background: #fce7eb !important;
    }
    &.disabled {
      color: #c8c9cc !important;
      background: #f2f3f5 !important;
    }
  }
}

.goods-lable {
  font-size: 0.26rem;
  padding-left: 0.2rem;
  margin-top: 0.05rem;
  color: #666;
}
</style>
<style lang='scss'>
.addGoods {
  .van-popup {
    overflow: initial !important;
  }
}
</style>
